mod solutions;
mod utils;

use std::error::Error;

use solutions::*;

fn main() -> Result<(), Box<dyn Error>> {
    let days: Vec<Box<dyn Solution>> = vec![
        Box::new(day01::Day01 {}),
        Box::new(day02::Day02 {}),
        Box::new(day03::Day03 {}),
        Box::new(day04::Day04 {}),
    ];

    // Run through and generate solutions
    for day in days.iter().rev() {
        day.run()?;
    }

    Ok(())
}
